<!-- eslint-disable -->
<i18n>
{
  "de": {
    "objectslink": "Alle Objekte",
    "PAR": {
      "objectslink": "@:objectslink"
    },
    "MGT": {
      "objectslink": "@:objectslink"
    }
  },
  "fr": {
  }
}
</i18n>
<!-- eslint-enable -->

<template>
  <div id="snapshotview">
    <!-- <v-navigation-drawer
      v-if="$store.state.notIframe"
      id="snapshotnav"
      clipped="clipped"
      app
      width="320"
      v-model="snapshotnav">
      <router-link id="logo" :to="'/' + $i18n.locale + '/'" class="px-4 py-4 d-block">
        <img alt="dføur logo" height="36" src="@/assets/images/logo.svg">
      </router-link>

      <v-divider />

      <div id="snapshotnavContent" class="ma-4">

        <div class="nodata pb-8">
          <div class="smaller hint">
            <h4>{{ title }}</h4>
            <p class="show-linebreaks">{{ description }}</p>
            <v-btn
              v-if="annotations.object.showlink"
              :to="'/' + $i18n.locale + '/' + wshash + '/annotations/OBJ/'"
              class="listlink elevation-0"
              block
            >
              <v-icon left>
                mdi-view-grid
              </v-icon>
              {{ $t('objectslink') }}
            </v-btn>
          </div>
        </div>

        <snapshot-list
          :snapshots="snapshotsWorkspace"
          :workspaceHash="wshash"
          :snapshotHash="hash"
          v-on:editme="editSnapshot"
        />

        <v-btn
          v-if="$store.state.isUserLoggedIn"
          fab color="primary"
          @click="newSnapshot" >
        <v-icon>mdi-plus</v-icon>
        </v-btn>
      </div>

      <v-toolbar
        width="320"
        absolute
        bottom>
        <div class="useractions">
          <user-actions noLogin="1" />
        </div>
        <v-spacer />
        <language-switch />
      </v-toolbar>
    </v-navigation-drawer> -->

    <snapshot-map ref="snapshot" v-if="hash && !annokind"
      :hash="hash" :wshash="wshash" :snapshot="snapshot"
      :annotations="annotations" :entry-active="entryActive"
      :spatialDatasettes="spatialDatasettes"
      :countryCode="countryCode"
      :geoboundsIn="geobounds" />

    <annotations-list ref="snapshot" v-if="annokind"
      :annotations="annotations.items" :kind="annokind"
      :categories="annotations.categories" :states="annotations.states" />

    <v-overlay absolute="absolute" opacity="0.2" z-index="1002"
      :value="!!editing">
      <snapshot-edit v-if="editing" :isNew="editing.isNew"
        v-bind="editing.snapshot" v-on:cancel="abortEdit"
        v-on:saved="onSnapshotSaved" />
    </v-overlay>

    <error-message :settings="errorsettings" />

  </div>
</template>

<style>
#snapshotview .v-text-field--outlined fieldset {
  border-color: rgba(0, 0, 0, 0.12);
}

#snapshotview .gemeindesuche input::placeholder {
  color: #000;
  opacity: 1;
  font-weight: 900;
}

.show-linebreaks {
  white-space: pre-wrap;
}

h4 {
  margin-bottom: 0.8em;
}

.listlink {
  text-transform: initial;
  font-weight: 700;
  font-size: 13px;
  opacity: 1;
  letter-spacing: 0;
}

.listlink span {
  justify-content: flex-start;
}
</style>

<script>
import Vue from 'vue';
import gql from 'graphql-tag';
import AnnotationsList from '../components/AnnotationsList.vue';
import SnapshotList from '../components/SnapshotList.vue';
import SnapshotMap from '../components/SnapshotMap.vue';
import SnapshotEdit from '../components/SnapshotEdit.vue';
import ErrorMessage from '../components/ErrorMessage.vue';


Vue.component('annotations-list', AnnotationsList);
Vue.component('snapshot-list', SnapshotList);
Vue.component('snapshot-map', SnapshotMap);
Vue.component('snapshot-edit', SnapshotEdit);
Vue.component('error-message', ErrorMessage);

export default {
  data() {
    return {
      hash: this.$route.params.hash || this.$attrs.hash,
      wshash: this.$route.params.wshash || this.$attrs.wshash,
      annokind: this.$route.params.annokind || this.$attrs.annokind || null,
      annoid: this.$route.params.annoid || null,
      snapshot: null,
      annotations: {
        items: [],
        categories: null,
        states: null,
        usergroups: null,
        mode: '',
        findme: false,
        marker: {
          open: false,
          likes: false
        },
        polygon: {
          open: false,
          likes: false
        },
        object: {
          open: false,
          likes: false
        }
      },
      spatialDatasettes: null,
      geobounds: [],
      municipalityName: '',
      snapshotsWorkspace: [],
      title: '',
      description: '',
      errorsettings: {},
      editing: undefined,
      countryCode: 'CH'
    };
  },

  props: {
    entryActive: String
  },

  async mounted() {
    await this.getWorkspaceInfo();
    if (this.hash) {
      await this.getWorkspaceData();
    }
    if (this.snapshot) {
      // this.$refs.snapshot.setupMeta();
      this.$refs.snapshot.setupMap();
      document.title = `dføur – ${this.title}`;
      if (this.annoid) {
        // const index = this.annotations.items.findIndex(a => a.pk === parseInt(this.annoid, 10));
        // this.$refs.snapshot.showPopup({ target: { feature: { kind: 'OBJ', index } } });
      }
    }
  },

  computed: {
    municipality() {
      if (this.$route.params.hasOwnProperty('municipality') && this.$route.params.municipality) {
        return this.$route.params.municipality;
      }
      return null;
    },

    snapshotnav: {
      get() {
        return this.$store.state.snapshotnav;
      },
      set(val) {
        this.$store.commit('setSnapshotnav', val);
      }
    }
  },

  methods: {
    async getWorkspaceInfo() {
      let workspaceInfo = this.$store.state.workspaceInfo;

      if (workspaceInfo) {
        this.wshash = workspaceInfo.pk;
        this.hash = workspaceInfo.snapshots[0].pk;
      } else {
        const result = await this.$apollo.query({
          query: gql`
            query getconfig($language: LanguageCodeEnum, $domain: String) {
              projectBy(domain: $domain) {
                countryCode
                workspace {
                  pk
                  title(languageCode: $language)
                  snapshots {
                    pk
                  }
                }
              }
            }
          `,
          variables: {
            hash: btoa(`SnapshotNode:${this.hash}`),
            domain: window.location.origin
          }
        }).catch((error) => {
          this.errorsettings = { type: 'netwokerror', open: true, error };
        });
        if (result) {
          if (result.data.hasOwnProperty('snapshots') && result.data.snapshots) {
            workspaceInfo = result.data.workspace;
            this.hash = workspaceInfo.snapshots[0].pk;
            this.countryCode = result.data.countryCode;
          } else {
            this.$router.push({ name: 'home' });
          }
        }
      }

      const annotationsProxy = `${process.env.VUE_APP_ASSETBASEURL}/workspace/${this.$route.params.lang}/${this.wshash}.json`;
      const res = await fetch(annotationsProxy, {
        method: 'GET',
        headers: { 'Content-Type': 'application/json' }
      });
      if (!res.ok) {
        throw new Error(`${res.status}: ${res.statusText}`);
      }
      const json = await res.json();
      const workspace = json.data.workspace;

      // if (workspaceInfo.snapshot) {
      //   const snapshot = workspaceInfo.snapshot;
      //   if (!workspace.snapshots.map(s => s.pk).includes(snapshot.pk)) {
      //     this.$router.push({ name: 'home' });
      //   }
      //   this.municipalityName = snapshot.municipality.fullname;
      //   this.$store.commit('setBfsnumber', snapshot.municipality.bfsNumber);
      //   this.$store.commit('setBfsname', snapshot.municipality.fullname);
      // }

      this.snapshotsWorkspace = workspace.snapshots;
      this.annotations.items = workspace.annotations;
      this.annotations.categories = workspace.categories;
      this.annotations.states = workspace.states;
      this.annotations.usergroups = workspace.usergroups;
      this.annotations.mode = workspace.mode;
      this.annotations.findme = workspace.findmeEnabled;
      this.annotations.marker.open = workspace.annotationsOpen;
      this.annotations.marker.likes = workspace.annotationsLikesEnabled;
      this.annotations.polygon.open = workspace.polygonOpen;
      this.annotations.polygon.likes = workspace.polygonLikesEnabled;
      this.annotations.object.open = workspace.objectOpen;
      this.annotations.object.likes = workspace.objectLikesEnabled;
      this.annotations.object.showlink = workspace.objectsPageLink;

      this.spatialDatasettes = workspace.spatialDatasettes;
      this.title = workspace.title;
      this.description = workspace.description;
    },

    async getWorkspaceData() {
      const result = await this.$apollo.query({
        query: gql`query getworkspace($wshash: ID!, $hash: ID!) {
          workspace(id: $wshash) {
            id
            pk
            title
          }
          snapshot(id: $hash) {
            id
            pk
            data
          }
        }`,
        variables: {
          wshash: btoa(`WorkspaceNode:${this.wshash}`),
          hash: btoa(`SnapshotNode:${this.hash}`)
        },
        options: {
          cachePolicy: 'no-cache'
        }
      }).catch((error) => {
        this.errorsettings = { type: 'netwokerror', open: true, error };
      });
      if (result) {
        if (result.data.hasOwnProperty('workspace') && result.data.workspace) {
          this.snapshot = result.data.snapshot.data;
        } else {
          this.$router.push({ name: 'home' });
        }
      }
    },
    editSnapshot(snapshot) {
      this.editing = { isNew: false, snapshot };
    },
    abortEdit() {
      this.editing = undefined;
    },
    async onSnapshotSaved() {
      const { data } = await this.$apollo.query({
        query: gql`query getworkspace($wshash: ID!) {
            workspace(id: $wshash) {
              snapshots {
                id
                pk
                title
                topic
                screenshot
                thumbnail
                datafile
                municipality {
                  bfsNumber
                  fullname
                }
              }
            }
          }
        `,
        variables: {
          wshash: btoa(`WorkspaceNode:${this.wshash}`)
        },
        fetchPolicy: 'no-cache'
      });
      // abusing vue's watching of Array.prototype.splice because it just wouldn't react otherwise
      this.snapshotsWorkspace.splice(
        0,
        this.snapshotsWorkspace.length,
        ...data.workspace.snapshots
      );
      this.editing = undefined;

      // if (this.$route.params.hash === snapshot.pk) {
      //   // current snapshot was updated, reload window
      //   this.$router.go();
      // } else {
      //   // co to edited snapshot
      //   this.$router.push(`/${
      //     this.$route.params.lang
      //   }/${
      //     this.$route.params.wshash
      //   }/${
      //     snapshot.pk
      //   }/`);
      // }
    },
    newSnapshot() {
      this.editing = { isNew: true, snapshot: {} };
    }
  }
};
</script>
